#include <string.h>
#include <stdio.h>

#include "netDataStructs.h"


int getDataType(char *netstring)
{
  static int type;

  sscanf(netstring, "%d_", &type);

  return(type);
  
  

}

int deserializePositionControl(char *netstring, POSITION_CONTROL_DATA *data)
{
  sscanf(netstring,"%d_%c_%5lf_%5lf_%5lf_%5lf_%5lf_%5lf_%5lf_", &data->type, &data->whichJpos, &data->JPos[0], &data->JPos[1], &data->JPos[2], &data->JPos[3], &data->JPos[4], &data->JPos[5], &data->JPos[6]);

  return(1);
}
int deserializeEndpointControl(char *netstring, ENDPOINT_CONTROL_DATA *data)
{
  sscanf(netstring, "%d_%c_%5lf_%5lf_%5lf_", &data->type, &data->whichEndpoint, &data->endpoint[0], &data->endpoint[1], &data->endpoint[2]);

  return(1);
}
int deserializeWAMStatus(char *netstring, WAM_STATE_DATA *data)
{
     sscanf(netstring, "%d_%lf_%lf_%lf_%lf_%lf_%lf_%lf_%lf_%lf_%lf_", &data->type, &data->JPos[0], &data->JPos[1], &data->JPos[2], &data->JPos[3], &data->JPos[4], &data->JPos[5], &data->JPos[6], &data->endpoint[0], &data->endpoint[1], &data->endpoint[2]);

     fprintf(stderr, "%s ---- %lf %lf %lf %lf\n", netstring, data->JPos[0], data->JPos[1], data->JPos[2], data->JPos[3]);
     
     return(1);
}

int deserializeEXTWAMStatus(char *netstring, WAM_EXT_STATE_DATA *data)
{

     sscanf(netstring, "%d_%5lf_%5lf_%5lf_%5lf_%5lf_%5lf_%5lf_%5lf_%5lf_%5lf_%d_", &data->type, &data->JPos[0], &data->JPos[1], &data->JPos[2], &data->JPos[3], &data->JPos[4], &data->JPos[5], &data->JPos[6], &data->endpoint[0], &data->endpoint[1], &data->endpoint[2], &data->nJoints);
     
     return(1);
}



int serializeData(void *data, char *netstring)
{
  static int type;
  static POSITION_CONTROL_DATA *pcd;
  static ENDPOINT_CONTROL_DATA *ecd;
  static WAM_STATE_DATA *wsd;
  static WAM_EXT_STATE_DATA *wesd;

  type = *((int *) data);

  switch(type)
    {
    case PositionData:
      pcd = (POSITION_CONTROL_DATA *) data;
      sprintf(netstring, "%d_%c_%5f_%5f_%5f_%5f_%5f_%5f_%5f_______", type, pcd->whichJpos, pcd->JPos[0], pcd->JPos[1], pcd->JPos[2], pcd->JPos[3], pcd->JPos[4], pcd->JPos[5], pcd->JPos[6]);
      break;
      
    case EndpointData:
      ecd = (ENDPOINT_CONTROL_DATA *) data;
      sprintf(netstring, "%d_%c_%5f_%5f_%5f_______", type, ecd->whichEndpoint, ecd->endpoint[0], ecd->endpoint[1], ecd->endpoint[2]);
      break;

    case WAMStatus:
      wsd = (WAM_STATE_DATA *) data;
      sprintf(netstring, "%d_%lf_%lf_%lf_%lf_%lf_%lf_%lf_%lf_%lf_%lf______", type, wsd->JPos[0], wsd->JPos[1], wsd->JPos[2], wsd->JPos[3], wsd->JPos[4], wsd->JPos[5], wsd->JPos[6], wsd->endpoint[0], wsd->endpoint[1], wsd->endpoint[2]);

      break;

    case WAMExtStatus:
      wesd = (WAM_EXT_STATE_DATA *) data;
      sprintf(netstring, "%d_%5f_%5f_%5f_%5f_%5f_%5f_%5f_%5f_%5f_%5f_%d_____", type, wesd->JPos[0], wesd->JPos[1], wesd->JPos[2], wesd->JPos[3], wesd->JPos[4], wesd->JPos[5], wesd->JPos[6], wesd->endpoint[0], wesd->endpoint[1], wesd->endpoint[2], wesd->nJoints);
      break;

    }

  return(1);
}
