/* based on */
/* fpont 12/99 */
/* pont.net    */
/* udpClient.c */

#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <netdb.h>
#include <stdio.h>
#include <unistd.h>
#include <string.h> /* memset() */
#include <sys/time.h> /* select() */ 
#include <syslog.h>

#include "netDataStructs.h"
#include "udpClient.h"
#include "netFuncs.h"

#define REMOTE_SERVER_PORT 9876

static struct sockaddr_in cliAddr, remoteServAddr;

static int remoteAddrSize;
static int sd;

int setupClient(char *hostname) {
  
  int rc;
  struct hostent *h;

  /* get server IP address (no check if input is IP address or DNS name */
  h = gethostbyname(hostname);
  if(h==NULL) {
    syslog(LOG_ERR, "udpConnector: unknown host '%s' \n",  hostname);
  }

  /*  printf("udpConnector: sending data to '%s' (IP : %s) \n", h->h_name,
      inet_ntoa(*(struct in_addr *)h->h_addr_list[0]));*/

  remoteServAddr.sin_family = h->h_addrtype;
  memcpy((char *) &remoteServAddr.sin_addr.s_addr, 
	 h->h_addr_list[0], h->h_length);
  remoteServAddr.sin_port = htons(REMOTE_SERVER_PORT);

  /* socket creation */
  sd = socket(AF_INET,SOCK_DGRAM,0);
  if(sd<0) {
    syslog(LOG_ERR,"udpConnector: cannot open socket \n");
  }
  
  /* bind any port */
  cliAddr.sin_family = AF_INET;
  cliAddr.sin_addr.s_addr = htonl(INADDR_ANY);
  cliAddr.sin_port = htons(0);
  
  rc = bind(sd, (struct sockaddr *) &cliAddr, sizeof(cliAddr));
  if(rc<0) {
    syslog(LOG_ERR, "udpConnector: cannot bind port\n");

  }

  remoteAddrSize = sizeof(remoteServAddr);
  return(1);
}

int sendData(void *data)
{
  static int res;
  static char message[MSG_SIZE];

  serializeData(data, message);
  
  res = sendto(sd, message, MSG_SIZE, 0x0, (struct sockaddr *) &remoteServAddr, remoteAddrSize);
  
  if(res < 0)
    {
      syslog(LOG_ERR, "udpConnector: cannot send data\n");
      return(res);
    }
  
  
  return(1);
}


