/* fpont 12/99 */
/* pont.net    */
/* udpServer.c */

#include <syslog.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <netdb.h>
#include <stdio.h>
#include <unistd.h> /* close() */
#include <string.h> /* memset() */

#include "udpServer.h"
#include "netDataStructs.h"
#define LOCAL_SERVER_PORT 9876

static struct sockaddr_in cliAddr;
static int cliLen;
static int sd;

void setupServer() {
  
  int rc;
  struct sockaddr_in servAddr;

  /* socket creation */
  sd=socket(AF_INET, SOCK_DGRAM, 0);

  if(sd<0) {
    syslog(LOG_ERR, "cannot open socket \n");
  }

  /* bind local server port */
  servAddr.sin_family = AF_INET;
  servAddr.sin_addr.s_addr = htonl(INADDR_ANY);
  servAddr.sin_port = htons(LOCAL_SERVER_PORT);
  rc = bind (sd, (struct sockaddr *) &servAddr,sizeof(servAddr));
  if(rc<0) {
    syslog(LOG_ERR, "cannot bind port number %d \n", LOCAL_SERVER_PORT);
  }

  cliLen = sizeof(cliAddr);
}

/* call this then deserialize in external function */
int receiveData(char *message)
{

  static int n;
  
  n = recvfrom(sd, message, MSG_SIZE, 0, (struct sockaddr *) &cliAddr, &cliLen);
  
  if(n<0) 
    {
      syslog(LOG_ERR, "Cannot receive data\n");
    }
  
  return(n);
  
}
